#!/usr/bin/python

from pprint import pformat

def reindent(string):
    """This is my first attempt at getting pretty printing."""
    output = []
    level = 0
    for substring in string.split('('):
        level += 1
        substring_ = substring + '(\n' + (level * '    ') #to put the ( back in
        suboutput = []
        for subsubstring in substring_.split(')'):
            level -= 1
            subsubstring_ = subsubstring + ')\n' + (level * '    ')
            suboutput.append(subsubstring_)
        suboutput[-1] = subsubstring #last one doesn't actually have a ) after it
        level += 1
        output.extend(suboutput)
    output = ''.join(output)
    output,_,_ = output.rpartition('(') #last one doesn't actually have a ( after it
    return output

class dbus:    
    """This is a really cheeky hack. I like it very much. 
    It lets you call eval() on the repr string, and returns something made of 
    standard python types, suitable for pretty-printing in the standard way.
    There is something slightly JSON about this, don't you think?
    Watch out though: dbus fails at type inference on variant valued dictionaries, 
    so you can't always pass this into a dbus method."""
    @staticmethod
    def String(s, *args, **kwargs):
        return str(s)
    @staticmethod
    def Dictionary(d, *args, **kwargs):
        return d
    @staticmethod
    def Array(a, *args, **kwargs):
        return a
    @staticmethod
    def Struct(s, *args, **kwargs):
        return s
    @staticmethod
    def ObjectPath(o, *args, **kwargs):
        return o
    @staticmethod
    def Signature(s, *args, **kwargs):
        return s
    @staticmethod
    def UInt32(s, *args, **kwargs):
        return s
    @staticmethod
    def Int32(s, *args, **kwargs):
        return s
    @staticmethod
    def Boolean(s, *args, **kwargs):
        return s
        
        
def clean(printed):
    return pformat(eval(printed))
    
    


if __name__ == "__main__":
    print clean('''dbus.Array([dbus.Struct((dbus.String(u'account'), dbus.UInt32(3L), dbus.String(u's'), dbus.String(u'', variant_level=1)), signature=None), dbus.Struct((dbus.String(u'password'), dbus.UInt32(3L), dbus.String(u's'), dbus.String(u'', variant_level=1)), signature=None), dbus.Struct((dbus.String(u'server'), dbus.UInt32(0L), dbus.String(u's'), dbus.String(u'', variant_level=1)), signature=None), dbus.Struct((dbus.String(u'resource'), dbus.UInt32(0L), dbus.String(u's'), dbus.String(u'', variant_level=1)), signature=None), dbus.Struct((dbus.String(u'priority'), dbus.UInt32(4L), dbus.String(u'n'), dbus.Int32(0, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'port'), dbus.UInt32(4L), dbus.String(u'q'), dbus.UInt32(5222L, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'old-ssl'), dbus.UInt32(4L), dbus.String(u'b'), dbus.Boolean(False, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'require-encryption'), dbus.UInt32(4L), dbus.String(u'b'), dbus.Boolean(False, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'register'), dbus.UInt32(4L), dbus.String(u'b'), dbus.Boolean(False, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'low-bandwidth'), dbus.UInt32(4L), dbus.String(u'b'), dbus.Boolean(False, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'https-proxy-server'), dbus.UInt32(0L), dbus.String(u's'), dbus.String(u'', variant_level=1)), signature=None), dbus.Struct((dbus.String(u'https-proxy-port'), dbus.UInt32(4L), dbus.String(u'q'), dbus.UInt32(443L, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'fallback-conference-server'), dbus.UInt32(0L), dbus.String(u's'), dbus.String(u'', variant_level=1)), signature=None), dbus.Struct((dbus.String(u'stun-server'), dbus.UInt32(0L), dbus.String(u's'), dbus.String(u'', variant_level=1)), signature=None), dbus.Struct((dbus.String(u'stun-port'), dbus.UInt32(4L), dbus.String(u'q'), dbus.UInt32(3478L, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'fallback-stun-server'), dbus.UInt32(4L), dbus.String(u's'), dbus.String(u'stun.collabora.co.uk', variant_level=1)), signature=None), dbus.Struct((dbus.String(u'fallback-stun-port'), dbus.UInt32(4L), dbus.String(u'q'), dbus.UInt32(3478L, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'ignore-ssl-errors'), dbus.UInt32(4L), dbus.String(u'b'), dbus.Boolean(False, variant_level=1)), signature=None), dbus.Struct((dbus.String(u'alias'), dbus.UInt32(0L), dbus.String(u's'), dbus.String(u'', variant_level=1)), signature=None), dbus.Struct((dbus.String(u'fallback-socks5-proxies'), dbus.UInt32(4L), dbus.String(u'as'), dbus.Array([dbus.String(u'proxy.jabber.org'), dbus.String(u'proxy.jabberfr.org'), dbus.String(u'proxy65.rooyee.biz'), dbus.String(u'proxy.jabbim.cz'), dbus.String(u'proxy.911910.cn'), dbus.String(u'proxy.downtempo.de'), dbus.String(u'proxy.im.flosoft.biz'), dbus.String(u'proxy.jabber.bluendo.com'), dbus.String(u'proxy.jabber.dk'), dbus.String(u'proxy.jabber.freenet.de'), dbus.String(u'proxy.fsinf.at'), dbus.String(u'proxy.jabber.minus273.org'), dbus.String(u'proxy.jabber.planetteamspeak.com'), dbus.String(u'proxy.jabber.tf-network.de'), dbus.String(u'proxy.jabjab.de'), dbus.String(u'proxy.jabster.pl'), dbus.String(u'proxy.schokokeks.org'), dbus.String(u'proxy.ubuntu-jabber.de'), dbus.String(u'proxy.ubuntu-jabber.net'), dbus.String(u'proxy65.unstable.nl'), dbus.String(u'proxy.verdammung.org'), dbus.String(u'proxy.vke.ru'), dbus.String(u'proxy.vodka-pomme.net'), dbus.String(u'proxy.jabbernet.eu')], signature=dbus.Signature('s'), variant_level=1)), signature=None), dbus.Struct((dbus.String(u'keepalive-interval'), dbus.UInt32(4L), dbus.String(u'u'), dbus.UInt32(30L, variant_level=1)), signature=None)], signature=dbus.Signature('(susv)'))''')